libstdc++: __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > Class Template Reference

`#include <left_child_next_sibling_heap_.hpp>`

Inheritance diagram for __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >:
[legend]

## Public Types
typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef left_child_next_sibling_heap_const_iterator_< node, _Alloc > | const_iterator
typedef __rebind_v::const_pointer | const_pointer
typedef __rebind_v::const_reference | const_reference
typedef _Alloc::difference_type | difference_type
typedef const_iterator | iterator
typedef left_child_next_sibling_heap_node_< Value_Type, Node_Metadata, _Alloc > | node
typedef left_child_next_sibling_heap_node_point_const_iterator_< node, _Alloc > | point_const_iterator
typedef point_const_iterator | point_iterator
typedef __rebind_v::pointer | pointer
typedef __rebind_v::reference | reference
typedef _Alloc::size_type | size_type
typedef Value_Type | value_type

## Public Member Functions
| left_child_next_sibling_heap (const Cmp_Fn &)
| left_child_next_sibling_heap (const left_child_next_sibling_heap &)
iterator | begin ()
const_iterator | begin () const
void | clear ()
bool | empty () const
iterator | end ()
const_iterator | end () const
Cmp_Fn & | get_cmp_fn ()
const Cmp_Fn & | get_cmp_fn () const
size_type | max_size () const
size_type | size () const
void | swap (left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > &)

## Protected Types
typedef alloc_traits::allocator_type | node_allocator
typedef alloc_traits::const_pointer | node_const_pointer
typedef Node_Metadata | node_metadata
typedef alloc_traits::pointer | node_pointer
typedef std::pair< node_pointer, node_pointer > | node_pointer_pair

## Protected Member Functions
void | actual_erase_node (node_pointer)
void | bubble_to_top (node_pointer)
void | clear_imp (node_pointer)
node_pointer | get_new_node_for_insert (const_reference)
template<typename Pred>
node_pointer | prune (Pred)
void | swap_with_parent (node_pointer, node_pointer)
void | to_linked_list ()
void | value_swap (left_child_next_sibling_heap &)

## Static Protected Member Functions
static void | make_child_of (node_pointer, node_pointer)
static node_pointer | parent (node_pointer)

## Protected Attributes
node_pointer | m_p_root
size_type | m_size

## Detailed Description

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>
class __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >

Base class for a basic heap.

Definition at line 90 of file left_child_next_sibling_heap_.hpp.

## Member Typedef Documentation

## ◆ allocator_type

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef _Alloc __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::allocator_type

Definition at line 139 of file left_child_next_sibling_heap_.hpp.

## ◆ cmp_fn

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef Cmp_Fn __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::cmp_fn

Definition at line 138 of file left_child_next_sibling_heap_.hpp.

## ◆ const_iterator

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef left_child_next_sibling_heap_const_iterator_<node, _Alloc> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_iterator

Definition at line 135 of file left_child_next_sibling_heap_.hpp.

## ◆ const_pointer

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef __rebind_v::const_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_pointer

Definition at line 125 of file left_child_next_sibling_heap_.hpp.

## ◆ const_reference

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef __rebind_v::const_reference __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_reference

Definition at line 127 of file left_child_next_sibling_heap_.hpp.

## ◆ difference_type

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef _Alloc::difference_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::difference_type

Definition at line 121 of file left_child_next_sibling_heap_.hpp.

## ◆ iterator

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef const_iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::iterator

Definition at line 137 of file left_child_next_sibling_heap_.hpp.

## ◆ node

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef left_child_next_sibling_heap_node_<Value_Type, Node_Metadata, _Alloc> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node

Definition at line 95 of file left_child_next_sibling_heap_.hpp.

## ◆ node_allocator

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef alloc_traits::allocator_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_allocator
| protected

Definition at line 101 of file left_child_next_sibling_heap_.hpp.

## ◆ node_const_pointer

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef alloc_traits::const_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_const_pointer
| protected

Definition at line 104 of file left_child_next_sibling_heap_.hpp.

## ◆ node_metadata

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef Node_Metadata __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_metadata
| protected

Definition at line 105 of file left_child_next_sibling_heap_.hpp.

## ◆ node_pointer

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef alloc_traits::pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_pointer
| protected

Definition at line 103 of file left_child_next_sibling_heap_.hpp.

## ◆ node_pointer_pair

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef std::pair<node_pointer, node_pointer> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_pointer_pair
| protected

Definition at line 106 of file left_child_next_sibling_heap_.hpp.

## ◆ point_const_iterator

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef left_child_next_sibling_heap_node_point_const_iterator_<node, _Alloc> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::point_const_iterator

Definition at line 130 of file left_child_next_sibling_heap_.hpp.

## ◆ point_iterator

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef point_const_iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::point_iterator

Definition at line 132 of file left_child_next_sibling_heap_.hpp.

## ◆ pointer

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef __rebind_v::pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::pointer

Definition at line 124 of file left_child_next_sibling_heap_.hpp.

## ◆ reference

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef __rebind_v::reference __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::reference

Definition at line 126 of file left_child_next_sibling_heap_.hpp.

## ◆ size_type

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef _Alloc::size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::size_type

Definition at line 120 of file left_child_next_sibling_heap_.hpp.

## ◆ value_type

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

typedef Value_Type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::value_type

Definition at line 122 of file left_child_next_sibling_heap_.hpp.

## Constructor & Destructor Documentation

## ◆ left_child_next_sibling_heap() [1/3]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::left_child_next_sibling_heap | ( |  | ) |

Definition at line 53 of file left_child_next_sibling_heap_.hpp.

## ◆ left_child_next_sibling_heap() [2/3]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::left_child_next_sibling_heap | ( | const Cmp_Fn & | r_cmp_fn | ) |

Definition at line 62 of file left_child_next_sibling_heap_.hpp.

## ◆ left_child_next_sibling_heap() [3/3]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::left_child_next_sibling_heap | ( | const left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > & | other | ) |

Definition at line 72 of file left_child_next_sibling_heap_.hpp.

## ◆ ~left_child_next_sibling_heap()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::~left_child_next_sibling_heap | ( |  | ) |

Definition at line 106 of file left_child_next_sibling_heap_.hpp.

## Member Function Documentation

## ◆ actual_erase_node()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::actual_erase_node | ( | node_pointer | p_nd | ) |
| inlineprotected

Definition at line 56 of file left_child_next_sibling_heap_.hpp.

## ◆ begin() [1/2]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::begin | ( |  | ) |
| inline

Definition at line 46 of file left_child_next_sibling_heap_.hpp.

## ◆ begin() [2/2]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::begin | ( |  | ) | const
| inline

Definition at line 62 of file left_child_next_sibling_heap_.hpp.

## ◆ bubble_to_top()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::bubble_to_top | ( | node_pointer | p_nd | ) |
| protected

Definition at line 143 of file left_child_next_sibling_heap_.hpp.

## ◆ clear()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::clear | ( |  | ) |

Definition at line 46 of file left_child_next_sibling_heap_.hpp.

## ◆ clear_imp()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::clear_imp | ( | node_pointer | p_nd | ) |
| protected

Definition at line 67 of file left_child_next_sibling_heap_.hpp.

## ◆ empty()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

bool __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::empty | ( |  | ) | const
| inlinenodiscard

Definition at line 47 of file left_child_next_sibling_heap_.hpp.

## ◆ end() [1/2]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::end | ( |  | ) |
| inline

Definition at line 78 of file left_child_next_sibling_heap_.hpp.

## ◆ end() [2/2]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::const_iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::end | ( |  | ) | const
| inline

Definition at line 86 of file left_child_next_sibling_heap_.hpp.

## ◆ get_cmp_fn() [1/2]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

Cmp_Fn & __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::get_cmp_fn | ( |  | ) |

Definition at line 46 of file left_child_next_sibling_heap_.hpp.

## ◆ get_cmp_fn() [2/2]

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

const Cmp_Fn & __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::get_cmp_fn | ( |  | ) | const

Definition at line 52 of file left_child_next_sibling_heap_.hpp.

## ◆ get_new_node_for_insert()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::get_new_node_for_insert | ( | const_reference | r_val | ) |
| inlineprotected

Definition at line 46 of file left_child_next_sibling_heap_.hpp.

## ◆ make_child_of()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::make_child_of | ( | node_pointer | p_nd,
|  | node_pointer | p_new_parent )
| inlinestaticprotected

Definition at line 90 of file left_child_next_sibling_heap_.hpp.

## ◆ max_size()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::max_size | ( |  | ) | const
| inline

Definition at line 63 of file left_child_next_sibling_heap_.hpp.

## ◆ parent()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::parent | ( | node_pointer | p_nd | ) |
| inlinestaticprotected

Definition at line 108 of file left_child_next_sibling_heap_.hpp.

## ◆ prune()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>
template<typename Pred>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::prune | ( | Pred | pred | ) |
| protected

Definition at line 113 of file left_child_next_sibling_heap_.hpp.

## ◆ size()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::size | ( |  | ) | const
| inline

Definition at line 55 of file left_child_next_sibling_heap_.hpp.

## ◆ swap()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::swap | ( | left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > & | other | ) |

Definition at line 85 of file left_child_next_sibling_heap_.hpp.

## ◆ swap_with_parent()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::swap_with_parent | ( | node_pointer | p_nd,
|  | node_pointer | p_parent )
| inlineprotected

Definition at line 124 of file left_child_next_sibling_heap_.hpp.

## ◆ to_linked_list()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::to_linked_list | ( |  | ) |
| protected

Definition at line 81 of file left_child_next_sibling_heap_.hpp.

## ◆ value_swap()

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::value_swap | ( | left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > & | other | ) |
| protected

Definition at line 98 of file left_child_next_sibling_heap_.hpp.

## Member Data Documentation

## ◆ m_p_root

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::m_p_root
| protected

Definition at line 270 of file left_child_next_sibling_heap_.hpp.

## ◆ m_size

template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>

size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >::m_size
| protected

Definition at line 271 of file left_child_next_sibling_heap_.hpp.

The documentation for this class was generated from the following file:

- left_child_next_sibling_heap_.hpp